// POUR LA LED N°1 :
const int PIN_RED_L1 = 7;
const int PIN_GREEN_L1 = 6;
const int PIN_BLUE_L1 = 5;
int counter = 0;
const int numColors = 255;

//POUR LA LED N°2 :
const int PIN_RED_L2 = 10;
const int PIN_GREEN_L2 = 8;
const int PIN_BLUE_L2 = 9;
int counter_2 = 1;

//POUR LE BOUTTON :
const int PIN_BUTTON_1 = 0;
int STATE_BUTTON_1 = 0;
bool while_setup;

//POUR LA TOTALITE DU SYSTEME :
const int animationDelay = 100; // temps avant que cela passe à la couleur suivante
int counter_3 = 0;

//FONCTION POUR LA LED N°1 :
void setColor (unsigned char red, unsigned char green, unsigned char blue) 
{        
    analogWrite(PIN_RED_L1, red);
    analogWrite(PIN_GREEN_L1, green);
    analogWrite(PIN_BLUE_L1, blue);
} 

long HSBtoRGB(float _hue, float _sat, float _brightness) {
    float red = 0.0;
    float green = 0.0;
    float blue = 0.0;
    
    if (_sat == 0.0) {
        red = _brightness;
        green = _brightness;
        blue = _brightness;
    } else {
        if (_hue == 360.0) {
            _hue = 0;
        }

        int slice = _hue / 60.0;
        float hue_frac = (_hue / 60.0) - slice;

        float aa = _brightness * (1.0 - _sat);
        float bb = _brightness * (1.0 - _sat * hue_frac);
        float cc = _brightness * (1.0 - _sat * (1.0 - hue_frac));
        
        switch(slice) {
            case 0:
                red = _brightness;
                green = cc;
                blue = aa;
                break;
            case 1:
                red = bb;
                green = _brightness;
                blue = aa;
                break;
            case 2:
                red = aa;
                green = _brightness;
                blue = cc;
                break;
            case 3:
                red = aa;
                green = bb;
                blue = _brightness;
                break;
            case 4:
                red = cc;
                green = aa;
                blue = _brightness;
                break;
            case 5:
                red = _brightness;
                green = aa;
                blue = bb;
                break;
            default:
                red = 0.0;
                green = 0.0;
                blue = 0.0;
                break;
        }
    }

    long ired = red * 255.0;
    long igreen = green * 255.0;
    long iblue = blue * 255.0;
    
    return long((ired << 16) | (igreen << 8) | (iblue));
}

void setup() {
  //POUR LA LED N°1 : 
  pinMode(PIN_RED_L1, OUTPUT);
  pinMode(PIN_BLUE_L1, OUTPUT);
  pinMode(PIN_GREEN_L1, OUTPUT);

  //POUR LA LED N°2 :
  pinMode(PIN_RED_L2, OUTPUT);
  pinMode(PIN_BLUE_L2, OUTPUT);
  pinMode(PIN_GREEN_L2, OUTPUT); 

  //POUR LE BOUTTON :
  pinMode(PIN_BUTTON_1, INPUT);
}
  

void loop() {
  //POUR LA LED N°1 :
  float colorNumber = counter > numColors ? counter - numColors: counter;
  float saturation = 1;       // Entre 0 et 1 (0 = gris, 1 = saturé)
  float brightness = 0.5;     // Entre 0 et 1 (0 = noir, 1 max lumiere)
  float hue = (colorNumber / float(numColors)) * 360;
  long color = HSBtoRGB(hue, saturation, brightness); 
  int red = color >> 16 & 255;
  int green = color >> 8 & 255;
  int blue = color & 255;
  setColor(red, green, blue);
  counter = (counter + 1) % (numColors * 2);

  //POUR LA LED N°2 :
  counter_2 += 1;
  if (counter_2 == 20)
  {
    digitalWrite(PIN_BLUE_L2, LOW);
    digitalWrite(PIN_RED_L2, HIGH);
  }
  if (counter_2 == 40)
  {
    digitalWrite(PIN_RED_L2, LOW);
    digitalWrite(PIN_GREEN_L2, HIGH);
  }
  if (counter_2 == 60)
  {
    digitalWrite(PIN_GREEN_L2, LOW);
    digitalWrite(PIN_BLUE_L2, HIGH);
    counter_2 = 0;
  }
  
  delay(animationDelay);

  STATE_BUTTON_1 = digitalRead(PIN_BUTTON_1);
  while_setup = 1;
  while (STATE_BUTTON_1 == LOW) 
    {
    if (while_setup)
      {
        STATE_BUTTON_1 = digitalRead(PIN_BUTTON_1);
        digitalWrite(PIN_GREEN_L1, LOW);
        digitalWrite(PIN_BLUE_L1, LOW);
    
        digitalWrite(PIN_GREEN_L2, LOW);
        digitalWrite(PIN_BLUE_L2, LOW);
        while_setup = 0;
      }
    
    counter_3 += 1; 
    delay(5);
    if (counter_3 == 20)
      {
      digitalWrite(PIN_RED_L2, HIGH);      
      digitalWrite(PIN_RED_L1, HIGH);
      }
    if (counter_3 == 40)
      {
      digitalWrite(PIN_RED_L2, LOW);
      digitalWrite(PIN_RED_L1, LOW);
      counter_3 == 0;
      }
    }
}
